!   D02PEF Example Program Text
!   Mark 24 Release. NAG Copyright 2012.

    Module d02pefe_mod

!     D02PEF Example Program Module:
!            Parameters and User-defined Routines

!     .. Use Statements ..
      Use nag_library, Only: nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Real (Kind=nag_wp), Parameter        :: tol0 = 1.0E-3_nag_wp
      Integer, Parameter                   :: liwsav = 130, n = 2, nin = 5,    &
                                              nout = 6, npts = 8
      Integer, Parameter                   :: lrwsav = 350 + 32*n
    Contains

      Subroutine f(t,n,y,yp,iuser,ruser)

!       .. Scalar Arguments ..
        Real (Kind=nag_wp), Intent (In)      :: t
        Integer, Intent (In)                 :: n
!       .. Array Arguments ..
        Real (Kind=nag_wp), Intent (Inout)   :: ruser(*)
        Real (Kind=nag_wp), Intent (In)      :: y(n)
        Real (Kind=nag_wp), Intent (Out)     :: yp(n)
        Integer, Intent (Inout)              :: iuser(*)
!       .. Executable Statements ..
        yp(1) = y(2)
        yp(2) = -y(1)
        Return
      End Subroutine f
    End Module d02pefe_mod

    Program d02pefe

!     D02PEF Example Main Program

!     .. Use Statements ..
      Use nag_library, Only: d02pef, d02pqf, d02ptf, nag_wp
      Use d02pefe_mod, Only: f, liwsav, lrwsav, n, nin, nout, npts, tol0
!     .. Implicit None Statement ..
      Implicit None
!     .. Local Scalars ..
      Real (Kind=nag_wp)                   :: hnext, hstart, tend, tgot, tinc, &
                                              tol, tstart, twant, waste
      Integer                              :: fevals, i, ifail, j, method,     &
                                              stepcost, stepsok
!     .. Local Arrays ..
      Real (Kind=nag_wp)                   :: ruser(1), thresh(n), ygot(n),    &
                                              yinit(n), ymax(n), ypgot(n)
      Real (Kind=nag_wp), Allocatable      :: rwsav(:)
      Integer                              :: iuser(1)
      Integer, Allocatable                 :: iwsav(:)
!     .. Intrinsic Procedures ..
      Intrinsic                            :: real
!     .. Executable Statements ..
      Write (nout,*) 'D02PEF Example Program Results'

      Allocate (iwsav(liwsav),rwsav(lrwsav))

!     Set initial conditions and input for D02PQF

!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) method
      Read (nin,*) tstart, tend
      Read (nin,*) yinit(1:n)
      Read (nin,*) hstart
      Read (nin,*) thresh(1:n)

!     Set control for output

      tinc = (tend-tstart)/real(npts,kind=nag_wp)

      tol = 10.0_nag_wp*tol0

loop: Do i = 1, 2
        tol = tol*0.1_nag_wp

!       ifail: behaviour on error exit   
!              =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
        ifail = 0
        Call d02pqf(n,tstart,tend,yinit,tol,thresh,method,hstart,iwsav,rwsav, &
          ifail)

        Write (nout,99999) tol
        Write (nout,99998)
        Write (nout,99997) tstart, yinit(1:n)
        twant = tstart
        Do j = 1, npts
          twant = twant + tinc

          ifail = 0
          Call d02pef(f,n,twant,tgot,ygot,ypgot,ymax,iuser,ruser,iwsav,rwsav, &
            ifail)

          Write (nout,99997) tgot, ygot(1:n)
        End Do

        ifail = 0
        Call d02ptf(fevals,stepcost,waste,stepsok,hnext,iwsav,rwsav,ifail)
        Write (nout,99996) fevals

      End Do loop

99999 Format (/' Calculation with TOL = ',1P,E8.1)
99998 Format (/'    t         y1        y2'/)
99997 Format (1X,F6.3,2(3X,F7.3))
99996 Format (/' Cost of the integration in evaluations of F is',I6)
    End Program d02pefe
